package dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting.GemCuttingMenu;
import java.util.List;
import net.minecraft.ChatFormatting;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.network.chat.Component;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.SimpleMenuProvider;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.HorizontalDirectionalBlock;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.phys.shapes.VoxelShape;

public class GemCuttingBlock extends HorizontalDirectionalBlock {
  public static final Component NAME = (Component)Component.m_237115_("menu.apotheosis.gem_cutting");
  
  public static final VoxelShape SHAPE = Shapes.m_83124_(m_49796_(0.0D, 12.0D, 0.0D, 16.0D, 16.0D, 16.0D), new VoxelShape[] { m_49796_(0.0D, 0.0D, 0.0D, 2.0D, 16.0D, 2.0D), m_49796_(0.0D, 0.0D, 14.0D, 2.0D, 16.0D, 16.0D), m_49796_(14.0D, 0.0D, 0.0D, 16.0D, 16.0D, 2.0D), m_49796_(14.0D, 0.0D, 14.0D, 16.0D, 16.0D, 16.0D) });
  
  public GemCuttingBlock(BlockBehaviour.Properties props) {
    super(props);
    m_49959_((BlockState)((BlockState)this.f_49792_.m_61090_()).m_61124_((Property)f_54117_, (Comparable)Direction.NORTH));
  }
  
  protected void m_7926_(StateDefinition.Builder<Block, BlockState> builder) {
    builder.m_61104_(new Property[] { (Property)f_54117_ });
  }
  
  public InteractionResult m_6227_(BlockState state, Level worldIn, BlockPos pos, Player player, InteractionHand handIn, BlockHitResult hit) {
    if (worldIn.f_46443_)
      return InteractionResult.SUCCESS; 
    player.m_5893_(m_7246_(state, worldIn, pos));
    return InteractionResult.CONSUME;
  }
  
  public MenuProvider m_7246_(BlockState state, Level world, BlockPos pos) {
    return (MenuProvider)new SimpleMenuProvider((id, pInv, player) -> new GemCuttingMenu(id, pInv, ContainerLevelAccess.m_39289_(world, pos)), NAME);
  }
  
  public VoxelShape m_5940_(BlockState pState, BlockGetter pLevel, BlockPos pPos, CollisionContext pContext) {
    return SHAPE;
  }
  
  public void m_5871_(ItemStack pStack, BlockGetter pLevel, List<Component> list, TooltipFlag pFlag) {
    list.add(Component.m_237115_(m_7705_() + ".desc").m_130940_(ChatFormatting.GRAY));
  }
  
  public BlockState m_5573_(BlockPlaceContext pContext) {
    return (BlockState)m_49966_().m_61124_((Property)f_54117_, (Comparable)pContext.m_8125_().m_122424_());
  }
}
